# Widgets

The widgets below were built with base textual widgets, and are meant to work together.

## CommandList
A simple text widget for displaying the commands for the shell.

![CommandList](../assets/widgets/command_list.png)

[CommandList Reference](command_list.md){ .md-button .md-button--primary }


## ConsoleLog
A RichLog widget for displaying logs generated by the command. 

![ConsoleLog](../assets/widgets/console_log.png)

[ConsoleLog Reference](console_log.md){ .md-button .md-button--primary }


## JobManager
A DataTable to show current running Jobs. 

![JobManager](../assets/widgets/job_manager.png)

[JobManager Reference](job_manager.md){ .md-button .md-button--primary }


## Prompt
The prompt for the shell. Is a sub component of the Shell widget.

![Prompt](../assets/widgets/prompt.png)

[Prompt Reference](prompt.md){ .md-button .md-button--primary }


## SettingsDisplay
Simple widget for displaying the shell variables.

![SettingsDisplay](../assets/widgets/settings.png)

[SettingsDisplay Reference](settings_display.md){ .md-button .md-button--primary }


## Shell
The primary widget for this extension.

[Shell Reference](shell/index.md){ .md-button .md-button--primary }


## ShellArea
Custom TextArea widget for mimicking shell-like behavior

[ShellArea Reference](shell_area.md){ .md-button .md-button--primary }


## Suggestions
The widget for showing auto-completion suggestions for the prompt. Is a sub component of the Shell widget.

![Suggestions](../assets/widgets/suggestions.png)

[Suggestions Reference](suggestions.md){ .md-button .md-button--primary }